-- name: [CS] \\#1BFF02\\Ben 10\\#FFFFFF\\ -\\#DD4416\\ Rath
-- description: Write blurb/description here!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Rath"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("rath_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("rath_icon") -- Located in "textures"

-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_RATH = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'Rwaaath.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Grr1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Grr2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Grr3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Ay.ogg', 'Gargh.ogg', 'Go.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'What.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Raaargh.ogg', 'Caat.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Nrrg.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Yummy.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Brwarg.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Okeydokey.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Bwaaaa.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Nrrg.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Grunt2.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Grunt1.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'RathFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'Wayou.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = {'Polaris_Piledriver.ogg', 'UrsaMajorBodySlam.ogg'}, 
	[CHAR_SOUND_HRMM] = 'Grunt1.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'Lemme_Tell_You.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = {'OphiucusSuplex', 'Sirius_Buttkicking.ogg', 'Antarean_Arm_Bar'}, -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = {'Nghh.ogg', 'Nrrg.org'}, -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Brbrbr.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Growl.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Grunt2.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Growl.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Grunt1.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = {'GoodKitty1.ogg', 'GoodKitty2.ogg', 'GoodKitty3.ogg'}, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Grr1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Gargh.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Now_Im_mad.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Brbrbr.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Grunt2.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_RATH = {
    normal = smlua_model_util_get_id("rath_normalcap_geo"),
    wing = smlua_model_util_get_id("rath_wingcap_geo"),
    metal = smlua_model_util_get_id("rath_metalcap_geo"),
}

local PALETTE_CHAR = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "060606",
    [SKIN]   = "EF4617",
    [CAP]    = "ffffff",
	[EMBLEM] = "1BFF02"
}

local HM_RATH= {
    label = {
        left = get_texture_info("LeftHealth"),
        right = get_texture_info("RightHealth"),
    },
    pie = {
        [1] = get_texture_info("Pie1"),
        [2] = get_texture_info("Pie2"),
        [3] = get_texture_info("Pie3"),
        [4] = get_texture_info("Pie4"),
        [5] = get_texture_info("Pie5"),
        [6] = get_texture_info("Pie6"),
        [7] = get_texture_info("Pie7"),
        [8] = get_texture_info("Pie8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_RATH = _G.charSelect.character_add("Rath", {"LEMME TELL YA SOMETHIN'!", "Rath is an Appoplexian, a alien with a tiger-like", "appearence from the planet Appoplexia, although he", "is very short tempered, he's a very muscular and", "strong opponent which can use his wrath to his", "advantage! Watch out, you don't want to be nearby", "when this guy is angry..."}, "Junior3DGames", {r = 239, g = 70, b = 23}, E_MODEL_CUSTOM_MODEL, CT_RATH, TEX_CUSTOM_LIFE_ICON, 1.2, 6)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_RATH)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_RATH)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_health_meter(CT_RATH, HM_RATH)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_RATH then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_RATH then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)